<?php

/*************************************************************
* Joomla Community Builder Groupjive Plugin
* $Rev::                                             $: Revision of last commit
* $Author::                                          $: Author of last commit
* $Date::                                            $: Date of last commit
* $Id::                                              $: ID
* @package Community Builder
* @author Michael Perthel <micha@voodootools.de>
* @link http://voodootools.de
* @ Released under GNU/GPL License : http://www.gnu.org/copyleft/gpl.html
*************************************************************/

defined( '_VALID_MOS' ) or die( 'Direct Access to this location is not allowed.' );

class getGroupjiveTab extends cbTabHandler {



	/**
	* Constructor
	*/	
	function getGroupjiveTab() {
		$this->cbTabHandler();
	}
	



	/**
	* Generates the HTML to display the user profile tab
	* @param object tab reflecting the tab database entry
	* @param object mosUser reflecting the user being displayed
	* @param int 1 for front-end, 2 for back-end
	* @returns mixed : string HTML for tab content
	*/	
	function getDisplayTab($tab,$user,$ui) {
		global $database, $mosConfig_lang, $mosConfig_live_site, $my, $mainframe;
		$mosConfig_absolute_path = $mainframe->getCfg('absolute_path');
		$gjp_path = $mosConfig_absolute_path.'/components/com_comprofiler/plugin/user/plug_groupjivetab';

		$sql = 'SELECT hideprivate FROM #__gj_options';
		$database->setQuery($sql);
		$hideprivate = $database->loadResult(); 

		if (file_exists($gjp_path.'/language/'.$mosConfig_lang.'.php')) {
			include_once($gjp_path.'/language/'.$mosConfig_lang.'.php');
		} else {
			include_once($gjp_path.'/language/english.php');
		}
		
		$return="";

	// get params
	$params = $this->params;
	$showcatimages = $params->get('gj_showcatimages', '1');
	$showgroupimages = $params->get('gj_showgroupimages', '1');
	$template = $params->get('gj_template', 'default.tmpl');

	// check if default logo exists
	if (file_exists($mosConfig_absolute_path
			. '/images/com_groupjive/tngroupjive_default.png')) {
		$defaultlogo = 'tngroupjive_default';
	} else {
		$defaultlogo = 'groupjive_mini.png';
	}

	// get groups from user
	if (!intval($user->id)) {
		die("Userid is not integer!");
	}
	$sSQL = 'SELECT id_group FROM #__gj_users '
		. 'WHERE id_user = '.$user->id 
		. ' AND status = "active"';  // only groups where the user is  active

		$database->setQuery($sSQL);
		$groupnums=$database->loadResultArray();

		//sql error handling
		if ($database->getErrorNum ()) {
			echo $database->stderr();
			return  false;
		} 

		
		// if there are no groups - return message
		if(!$groupnums) {
			return ;
		}

		// default CB image for specific language
		$thumbnail="/components/com_comprofiler/plugin/language/"
			. $fileLang."/images/tnnophoto.jpg";

		// check if default image exists in specific language
		if (file_exists($mosConfig_absolute_path.$thumbnail)) { 
			$defaultCbImage = $mosConfig_live_site.$thumbnail; 
		} else {
			$defaultCbImage = $mosConfig_live_site
				. "/components/com_comprofiler/plugin/"
				. "language/default_language/images/"
				. "tnnophoto.jpg"; 
		}  

		// if there are any groups return them
		$sSQLgroupNums = implode(", ", $groupnums);

		// get groups details
		$sSQL = 'SELECT a.id, a.name, a.descr, c.id as catid, c.catname, '
				. 'c.cat_image, a.logo, a.type, '
				. 'a.creator, a.user_id, d.avatar, COUNT(a.user_id) as membercount, '
				. 'e.id_user FROM #__gj_groups AS a '
				. 'INNER JOIN #__gj_users AS b ON a.id = b.id_group '
				. 'INNER JOIN #__gj_grcategory AS c ON a.category = c.id ' 
				. 'INNER JOIN #__comprofiler AS d ON a.user_id = d.id '
				. 'LEFT JOIN #__gj_users AS e '
				. 'ON a.id = e.id_group AND e.id_user = '.$my->id.' '
				. 'GROUP BY a.id, a.name, a.descr, c.id, c.catname, '
				. 'a.creator, a.user_id, d.avatar '
				. 'HAVING a.id IN ('. $sSQLgroupNums .')'
				. ' ORDER BY catname, name;';

		$database->setQuery($sSQL);
		$groups=$database->loadObjectList();

		//sql error handling
		if ($database->getErrorNum ()) {
			echo $database->stderr();
			return  false;
		} 

		// prepare template
		require_once( $mosConfig_absolute_path . '/includes/patTemplate/patTemplate.php' );
		$tmpl =& patFactory::createTemplate( $option, true, false );
		$tmpl->setRoot( dirname( __FILE__ ) . '/templates' );

		$tmpl->readTemplatesFromInput($template);
		$tmpl->addVar( 'cb_plugin_groupjive', 'USERNAME', $user->username);

		// count the groups 
		switch(count($groups)) {
			case 0 :  $tmpl->addVar( 'cb_plugin_groupjive', 'COUNT_GROUPS', UE_GROUPJIVE_NOGROUP );
					break;
			case 1 :  $tmpl->addVar( 'cb_plugin_groupjive', 'COUNT_GROUPS', 
								count($groups).' '.UE_GROUPJIVE_ONEGROUP );
					break;
			default : $tmpl->addVar( 'cb_plugin_groupjive', 'COUNT_GROUPS', 
								count($groups).' '.UE_GROUPJIVE_GROUPS );
					break;
		}

		// get current language for nophoto
		if(is_dir($mosConfig_absolute_path."/components/com_comprofiler/plugin/language/".
					$mosConfig_lang."/images")) {
			$fileLang=$mosConfig_lang; 
		} else {
			$fileLang="default_language";
		}

		// prepare the data
		$tmplrowdata = array();

		for ($j=0;$j<count($groups);$j++) {
			$tmplrow = get_object_vars($groups[$j]);
			// check if gallery image or custom image or nophoto
			if (substr($tmplrow['avatar'], 0, 7) == 'gallery') {
				$thumbnail = "/images/comprofiler/".$tmplrow['avatar'];
			} else if ($tmplrow['avatar'] != '') {
				$thumbnail = "/images/comprofiler/tn".$tmplrow['avatar'];
			} else {
				$thumbnail = $defaultCbImage;
			}

			// check if thumbnails exists
			if (file_exists($mosConfig_absolute_path.$thumbnail)) { 
				// image exists
				$image=$mosConfig_live_site.$thumbnail; 
			} else {
				$image = $defaultCbImage;
			}

			// check if category image exists
			if (!file_exists($mosConfig_absolute_path
				. '/images/com_groupjive/tn'
				. $tmplrow['cat_image'])) {
			$tmplrow['cat_image'] = '<img src="'.$mosConfig_live_site
				.'/images/com_groupjive/'.$defaultlogo 
				. '" style="border:none;" alt="'
				. $tmplrow['catname'].'" />';
			} else {
				$tmplrow['cat_image'] = '<img src="'.$mosConfig_live_site
					.'/images/com_groupjive/tn' 
					. $tmplrow['cat_image'].'" style="border:none;" alt="'
					. $tmplrow['catname'].'" />';
			}

			if ($showcatimages==1){
				$tmplrow['categorylink'] = '<a href="'.sefRelToAbs('index.php?option='
					. 'com_groupjive&amp;task=showcat&amp;id='
					. $tmplrow['catid']).'">'
					. $tmplrow['cat_image']
					. '<br />'.$tmplrow['catname'].'</a>';
			} else {
				$tmplrow['categorylink'] = '<a href="'.sefRelToAbs('index.php?option='
					. 'com_groupjive&amp;task=showcat&amp;id='
					. $tmplrow['catid']).'">'
					. $tmplrow['catname'].'</a>';
			}

			// check if group image exists
			if (!file_exists($mosConfig_absolute_path
				. '/images/com_groupjive/tn'
				. $tmplrow['logo'])) {
				$tmplrow['logo'] = '<img src="'.$mosConfig_live_site
					. '/images/com_groupjive/'.$defaultlogo 
					. '" style="border:none;" alt="'
					. $tmplrow['name'].'"/>';
			} else {
				$tmplrow['logo'] = '<img src="'.$mosConfig_live_site
					. '/images/com_groupjive/tn' 
					. $tmplrow['logo'].'" style="border:none;" alt="'
					. $tmplrow['name'].'"/>';
			}

			// Comprofiler image
			$tmplrow['creatorimage'] = $image;

			// check if visitor is still a member of the group        
			if ($tmplrow['id_user'] == $my->id) {
				$tmplrow['actionlink'] = "- ".UE_GROUPJIVE_ALREADY_MEMBER;
			} else {
				$tmplrow['actionlink'] = '- <a href="'.sefRelToAbs('index.php?option='
					. 'com_groupjive&amp;task=sign&amp;groupid='
					. $tmplrow['id']).'">'.UE_GROUPJIVE_JOINGROUP 
					. '</a>';
			}

			// link to visit the group
			$tmplrow['visitlink'] = '<a href="'.sefRelToAbs('index.php?option='
				. 'com_groupjive&amp;task=showgroup&amp;groupid='
				. $tmplrow['id']).'">'.UE_GROUPJIVE_VIEWGROUP.'</a>';

			if ($showgroupimages==1){
				$tmplrow['grouplink'] = '<a href="'.sefRelToAbs('index.php?'
					. 'option=com_groupjive&amp;'
					. 'task=showgroup&amp;groupid='
					. $tmplrow['id']).'">'.$tmplrow['logo']
					. '<br />'.$tmplrow['name'].'</a>';
			} else {
				$tmplrow['grouplink'] = '<a href="'.sefRelToAbs('index.php?'
					. 'option=com_groupjive&amp;'
					. 'task=showgroup&amp;groupid='
					. $tmplrow['id']).'">'.$tmplrow['name']
					. '</a>';
			}

			// check type
			if($tmplrow['type']==1) {
				$tmplrow['type'] = GJ_OPEN;
			} elseif($tmplrow['type']==2) {
				$tmplrow['type'] = GJ_APREQUIRED;
			} elseif($tmplrow['type']==3) {
				$tmplrow['type'] = GJ_PRIVATE;

				if ($tmplrow['id_user'] != $my->id) {
					$tmplrow['actionlink'] = '&nbsp;';
					$tmplrow['visitlink'] = '&nbsp;';
					$tmplrow['grouplink'] = $tmplrow['logo'].'<br>'.$tmplrow['name'];
				}
			}

			$tmplrow['cbFieldTip'] = cbFieldTip($ui, $tmplrow['descr'], $tmplrow['name']);

			if (!($hideprivate && $tmplrow['type'] == GJ_PRIVATE && $tmplrow['id_user'] != $my->id)) { 
				array_push($tmplrowdata, $tmplrow);
			}
		}

		$tmpl->addRows( 'groups_list', $tmplrowdata);

		return "<div style='display:block;width:100%;height:300px;overflow:auto;'>".$tmpl->getParsedTemplate( 'cb_plugin_groupjive' )."</div>";
	}
	
	function loadTemplateList($name,$value,$control_name) {
		global $mainframe;
		$templates = array();
		$templateBaseDir = mosPathName( dirname(__FILE__). '/templates' );

		if ($handle = opendir($templateBaseDir)) {
			while (false !== ($file = readdir($handle))) {
				if ($file != "." && $file != ".." && is_dir(dirname(__FILE__).'/templates/'.$file)==false) {
					$templates[] = mosHTML::makeOption($file, $file);
				}
			}
			closedir($handle);
		}
		return moscomprofilerHTML::selectList( $templates, $control_name .'['. $name .'][]', 'size="1"', 'value', 'text', $value, true );	
	}
} // end class getGroupjiveTab.
?>
